<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>Identity Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id284028"></a>Identity Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Alexander</span> <span class="surname">Christ</span></h3><div class="affiliation"><span class="orgname">Cologne University of Applied Sciences<br></span></div></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Alexander</span> <span class="surname">Christ</span></h3></div></div></div><div><p class="copyright">Copyright © 2007 Alexander Christ, Cologne University of Applied Sciences</p></div><div><div class="revhistory"><table border="1" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="2"><b>Revision History</b></th></tr><tr><td align="left">Revision $Revision: 5901 $</td><td align="left">$Date: 2007-03-29$</td></tr></table></div></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id277967">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id284067">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id284079">1.2. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id284084">1.2.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id248015">1.2.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id249277">1.3. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id249282">1.3.1. <code class="varname">privKey</code> (string)</a></span></dt><dt><span class="section"><a href="#id249593">1.3.2. <code class="varname">authCert</code> (string)</a></span></dt><dt><span class="section"><a href="#id249625">1.3.3. <code class="varname">certUri</code> (string)</a></span></dt><dt><span class="section"><a href="#id248387">1.3.4. <code class="varname">verCert</code> (string)</a></span></dt><dt><span class="section"><a href="#id248440">1.3.5. <code class="varname">caList</code> (string)</a></span></dt><dt><span class="section"><a href="#id293420">1.3.6. <code class="varname">crlList</code> (string)</a></span></dt><dt><span class="section"><a href="#id293454">1.3.7. <code class="varname">useCrls</code> (integer)</a></span></dt></dl></dd><dt><span class="section"><a href="#id293498">1.4. Exported Functions</a></span></dt><dd><dl><dt><span class="section"><a href="#id293503">1.4.1. 
		<code class="function">authservice()</code>
	    </a></span></dt><dt><span class="section"><a href="#id293596">1.4.2. 
		<code class="function">verifier()</code>
	    </a></span></dt></dl></dd><dt><span class="section"><a href="#id293699">1.5. Known Limitations</a></span></dt></dl></dd></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id249294">Set <code class="varname">privKey</code> parameter</a></dt><dt>1.2. <a href="#id249607">Set <code class="varname">authCert</code> parameter</a></dt><dt>1.3. <a href="#id249638">Set <code class="varname">certUri</code> parameter</a></dt><dt>1.4. <a href="#id248423">Set <code class="varname">verCert</code> parameter</a></dt><dt>1.5. <a href="#id293404">Set <code class="varname">caList</code> parameter</a></dt><dt>1.6. <a href="#id293438">Set <code class="varname">crlList</code> parameter</a></dt><dt>1.7. <a href="#id293481">Set <code class="varname">privKey</code> parameter</a></dt><dt>1.8. <a href="#id293568"><code class="function">authservice()</code> usage</a></dt><dt>1.9. <a href="#id293669"><code class="function">verifier()</code> usage</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id277967"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id284067"></a>1.1. Overview</h2></div></div></div><p>This module adds support for SIP Identity (see RFC 4474).</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id284079"></a>1.2. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id284084"></a>1.2.1. OpenSIPS Modules</h3></div></div></div><p>
		The following modules must be loaded before this module:
	    	</p><div class="itemizedlist"><ul type="disc"><li><p>
			    <span class="emphasis"><em>No dependencies on other OpenSIPS modules</em></span>.
			</p></li></ul></div><p>
	    </p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248015"></a>1.2.2. External Libraries or Applications</h3></div></div></div><p>
		The following libraries or applications must be installed before running
		OpenSIPS with this module loaded:
	    	</p><div class="itemizedlist"><ul type="disc"><li><p>
			    <span class="emphasis"><em>openssl (libssl)</em></span>.
			</p></li></ul></div><p>
	    </p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249277"></a>1.3. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249282"></a>1.3.1. <code class="varname">privKey</code> (string)</h3></div></div></div><p>
		Filename of private RSA-key of authentication service. This file must be in PEM format.
	    </p><div class="example"><a name="id249294"></a><p class="title"><b>Example 1.1. Set <code class="varname">privKey</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("identity", "privKey", "/etc/openser/privkey.pem")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249593"></a>1.3.2. <code class="varname">authCert</code> (string)</h3></div></div></div><p>
		Filename of certificate which belongs to <code class="varname">privKey</code>. This file must be in PEM format.
	    </p><div class="example"><a name="id249607"></a><p class="title"><b>Example 1.2. Set <code class="varname">authCert</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("identity", "authCert", "/etc/openser/cert.pem")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249625"></a>1.3.3. <code class="varname">certUri</code> (string)</h3></div></div></div><p>
		URI from which the certificate of the authentication service can be acquired. This string will be placed in the Identity-Info header.
	    </p><div class="example"><a name="id249638"></a><p class="title"><b>Example 1.3. Set <code class="varname">certUri</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("identity", "certUri", "http://www.myserver.com/cert.pem")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248387"></a>1.3.4. <code class="varname">verCert</code> (string)</h3></div></div></div><p>
		Path containing certificates for the verifier. Certificates must be in PEM format. The URI in the Identity-Info header field is used to find the corresponding certificate for the request. For this purpose the verifier replaces every character which is not alphanumeric, no &#8220;<span class="quote">_</span>&#8221; and no &#8220;<span class="quote">.</span>&#8221; with a &#8220;<span class="quote">-</span>&#8221;. A &#8220;<span class="quote">.</span>&#8221; at the beginning of the URI is forbidden. If the URI is &#8220;<span class="quote">http://www.test.com/cert.pem</span>&#8221; the verifier will look for the file &#8220;<span class="quote">http---www.test.com-cert.pem</span>&#8221;, for example.
		It is also possible to store a whole certificate chain in a file. In this case certificates must be in right order, end certificate first.
	    </p><div class="example"><a name="id248423"></a><p class="title"><b>Example 1.4. Set <code class="varname">verCert</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("identity", "verCert", "/etc/openser/verCert/")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248440"></a>1.3.5. <code class="varname">caList</code> (string)</h3></div></div></div><p>
		File containing all trusted (root) certificates for the verifier. Certificates must be in PEM format.
	    </p><div class="example"><a name="id293404"></a><p class="title"><b>Example 1.5. Set <code class="varname">caList</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("identity", "caList", "/etc/openser/caList.pem")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293420"></a>1.3.6. <code class="varname">crlList</code> (string)</h3></div></div></div><p>
		File containing certificate revocation lists (crls) for the verifier. Setting this parameter is only necessary if <code class="varname">useCrls</code> is set to &#8220;<span class="quote">1</span>&#8221;.
	    </p><div class="example"><a name="id293438"></a><p class="title"><b>Example 1.6. Set <code class="varname">crlList</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("identity", "crlList", "/etc/openser/crls.pem")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293454"></a>1.3.7. <code class="varname">useCrls</code> (integer)</h3></div></div></div><p>
		Switch to decide whether to use revocation lists (&#8220;<span class="quote">1</span>&#8221;) or not (&#8220;<span class="quote">0</span>&#8221;).
	    </p><p>
		<span class="emphasis"><em>
		    Default value is &#8220;<span class="quote">0</span>&#8221;.
		</em></span>
	    </p><div class="example"><a name="id293481"></a><p class="title"><b>Example 1.7. Set <code class="varname">privKey</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("identity", "useCrls", 1)
...
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293498"></a>1.4. Exported Functions</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293503"></a>1.4.1. 
		<code class="function">authservice()</code>
	    </h3></div></div></div><p>
		This function performs the steps of an authentication service. Before you call this function, you have to ensure
		that 
		</p><div class="itemizedlist"><ul type="disc"><li><p>the server is responsible for this request (from URI matches local SIP domain)
		    </p></li><li><p>the sender of the request is authorized to claim the identity given in the From header field.
		    </p></li></ul></div>
	    
	    This function returns the following values:
	    <div class="itemizedlist"><ul type="disc"><li><p>-3: Date header field does not match validity period of cert. Identity header has not been added.
			</p></li><li><p>-2: message out of time (e.g. message to old), Identity header has not been added.
		    </p></li><li><p>-1: An error occurred.
		    </p></li><li><p>1: everything OK, Identity header has been added.
		    </p></li></ul></div>
	     This function can be used from REQUEST_ROUTE.
	    <div class="example"><a name="id293568"></a><p class="title"><b>Example 1.8. <code class="function">authservice()</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
# CANCEL and ACK cannot be challenged
if ((method=="CANCEL") || (method=="ACK"))
{
    route(1); # forward
    exit;
}

# some clients (e.g. Kphone) do not answer, when a BYE is challenged
if (method=="BYE")
{
    route(1); # forward
    exit;
}

### Authentication Service ###

# check whether I am authoritative
if(!from_uri=~".*@mysipdomain.de")
{
    route(1); # forward
    exit;
}

if(!proxy_authorize("mysipdomain.de","subscriber"))
{
    proxy_challenge("mysipdomain.de","0");
    exit;
}

if (!db_check_from())
{
    sl_send_reply("403", "Use From=ID");
    exit;
}
consume_credentials();
        
authservice();
switch($retcode)
{
    case -3:
        xlog("L_DBG" ,"authservice: Date header field does not match validity period of cert\n");
        break;
    case -2:
        xlog("L_DBG" ,"authservice: msg out of time (max. +- 10 minutes allowed)\n");
        break;
    case -1:
        xlog("L_DBG" ,"authservice: ERROR, returnvalue: -1\n");
        break;
    case 1:
        xlog("L_DBG" ,"authservice: everything OK\n");
        break;
    default:
        xlog("L_DBG" ,"unknown returnvalue of authservice\n");
        
}

route(1); #forward with ($retcode=1) or without ($retcode!=1) Identity header
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293596"></a>1.4.2. 
		<code class="function">verifier()</code>
	    </h3></div></div></div><p>
		This function performs the steps of an verifier. The returned code tells you the result of the verification:
		</p><div class="itemizedlist"><ul type="disc"><li><p> -438: Signature does not correspond to the message. 438-response should be send.
		    </p></li><li><p>-437: Certificate cannot be validated. 437-response should be send.
		    </p></li><li><p>-436: Certificate is not available. 436-response should be send.
		    </p></li><li><p>-428: Message does not have an Identity header. 428-response should be send.
		    </p></li><li><p>-3: Error verifying Date header field.
		    </p></li><li><p>-2: Authentication service is not authoritative.
		    </p></li><li><p>-1: An unknown error occurred.
		    </p></li><li><p>1: verification OK
		    </p></li></ul></div>
	     This function can be used from REQUEST_ROUTE.
	    <div class="example"><a name="id293669"></a><p class="title"><b>Example 1.9. <code class="function">verifier()</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
# we have to define the same exceptions as we did for the authentication service
if ((method=="CANCEL") || (method=="ACK")) 
{ 
    route(1); # forward
    exit;
}
    
if (method=="BYE")
{
    route(1); # forward
    exit;
}
   
verifier();
switch($retcode)
{
    case -438:
        xlog("L_DBG" ,"verifier: returnvalue: -438\n");
        sl_send_reply("438", "Invalid Identity Header");
        exit;
        break;
    case -437:
        xlog("L_DBG" ,"verifier: returnvalue: -437\n");
        sl_send_reply("437", "Unsupported Certificate");
        exit;
        break;
    case -436:
        xlog("L_DBG" ,"verifier: returnvalue: -436\n");
        sl_send_reply("436", "Bad Identity-Info");
        exit;
        break;
    case -428:
        xlog("L_DBG" ,"verifier: returnvalue: -428\n");
        sl_send_reply("428", "Use Identity Header");
        exit;
        break;
    case -3:
        xlog("L_DBG" ,"verifier: error verifying Date header field\n");
        exit;
        break;
    case -2:
        xlog("L_DBG" ,"verifier: authentication service is not authoritative\n");
        exit;
        break;
    case -1:
        xlog("L_DBG" ,"verifier: ERROR, returnvalue: -1\n");
        exit;
        break;
    case 1:
        xlog("L_DBG" ,"verifier: verification OK\n");
        route(1); # forward
        exit;
        break;
    default:
        xlog("L_DBG" ,"unknown returnvalue of verifier\n");
        exit;
}
exit;
...
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293699"></a>1.5. Known Limitations</h2></div></div></div><p>
	
	</p><div class="itemizedlist"><ul type="disc"><li><p> Certificates are not downloaded. They have to be stored locally.
		    </p></li><li><p>Call-IDs of valid requests containing an Identity header are not recorded. 
				Hence the verifier does not provide full replay protection.
		    </p></li><li><p>Authentication service and verifier use the original request. Changes resulting from message processing in OpenSER script are ignored. 
		    </p></li></ul></div><p>
	
	</p></div></div></div></body></html>
