<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>QOS Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id249239"></a>QOS Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Ovidiu</span> <span class="surname">Sas</span></h3><div class="affiliation"><span class="orgname">SOMA Networks, Inc.<br></span></div></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Ovidiu</span> <span class="surname">Sas</span></h3></div></div></div><div><p class="copyright">Copyright © 2008 SOMA Networks, Inc.</p></div><div><div class="revhistory"><table border="1" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="2"><b>Revision History</b></th></tr><tr><td align="left">Revision $Revision: 5901 $</td><td align="left">$Date: 2009-07-21 09:45:05 +0200 (Tue, 21 Jul 2009) $</td></tr></table></div></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id249292">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id249280">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id248918">1.2. How it works</a></span></dt><dt><span class="section"><a href="#id249552">1.3. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id249558">1.3.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id249567">1.3.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id249593">1.4. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id248849">1.4.1. <code class="varname">qos_flag</code> (integer)</a></span></dt></dl></dd><dt><span class="section"><a href="#id248903">1.5. Exported Functions</a></span></dt><dt><span class="section"><a href="#id248913">1.6. Exported Statistics</a></span></dt><dt><span class="section"><a href="#id293408">1.7. Exported MI Functions</a></span></dt><dt><span class="section"><a href="#id293419">1.8. Exported pseudo-variables</a></span></dt><dt><span class="section"><a href="#id293428">1.9. Installation and Running</a></span></dt></dl></dd><dt><span class="chapter"><a href="#id293440">2. Developer Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id293458">2.1. Available Functions</a></span></dt><dd><dl><dt><span class="section"><a href="#id293443">2.1.1. 
		<code class="function">register_qoscb (qos, type, cb, param)</code>
		</a></span></dt></dl></dd></dl></dd></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id248881">Set <code class="varname">qos_flag</code> parameter</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id249292"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249280"></a>1.1. Overview</h2></div></div></div><p>The qos module provides a way to keep track of
		per dialog SDP session(s).</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248918"></a>1.2. How it works</h2></div></div></div><p>The qos module uses the dialog module to be notified of
	any new or updated dialogs.  It will then look for and extract
	the SDP session (if present) from SIP requests and replies and
	keep track of it for the entire life of a dialog.</p><p>All of this happens with a properly configured dialog
	and qos module and setting the dialog flag and the qos flag at
	the time any INVITE sip message is seen.  There is no
	config script function call required to set the SDP session
	tracking mechanism.  See the dialog module users guide for
	more information.</p><p>A dialog can have one or more SDP sessions active in one
	of the following states:
	</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>pending</em></span> - only one end point of the
	SDP session is known.
	</p></li><li><p><span class="emphasis"><em>negotiated</em></span> - both end points of the
	SDP session are known.
	</p></li></ul></div><p>
	</p><p>An SDP session can be established in one of the following
	scenarios:
	</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>INVITE/200ok</em></span> - typical "INVITE" and
	"200 OK" SDP exchange.
	</p></li><li><p><span class="emphasis"><em>200ok/ACK</em></span> - "200 OK" and  "ACK" SDP
	exchange (for calls starting with an empty INVITE).
	</p></li><li><p><span class="emphasis"><em>183/PRACK</em></span> - early media via "183
	Session Progress" and "PRACK" (see rfc3959 for more information) -
	not implemented yet.
	</p></li></ul></div><p>
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249552"></a>1.3. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249558"></a>1.3.1. OpenSIPS Modules</h3></div></div></div><p>The following modules must be loaded
		before this module:
		</p><div class="itemizedlist"><ul type="disc"><li><p>
		<span class="emphasis"><em>dialog</em></span> - dialog module and
		its decencies (tm).
		</p></li></ul></div><p>
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249567"></a>1.3.2. External Libraries or Applications</h3></div></div></div><p>
	The following libraries or applications must be installed before
	running OpenSIPS with this module loaded:
		</p><div class="itemizedlist"><ul type="disc"><li><p>
			<span class="emphasis"><em>None</em></span>.
		</p></li></ul></div><p>
	</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249593"></a>1.4. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248849"></a>1.4.1. <code class="varname">qos_flag</code> (integer)</h3></div></div></div><p>Keeping with OpenSIPS, the module will not do
		anything to any message unless instructed to do so via
		the config script. You must set the qos_flag
		value in the setflag() call of the INVITE you want the
		qos module to process. But before you can do that, you
		need to tell the qos module which flag value you are
		assigning to qos.</p><p>In most cases when ever you create a new dialog
		via create_dialog() function,you will want to set the qos flag. 
		If create_dialog() is not called and the qos flag is set, 
		it will not have any effect.</p><p>This parameter must be set of the module will
		not load.</p><p>
		<span class="emphasis"><em>
			Default value is &#8220;<span class="quote">Not set!</span>&#8221;.
		</em></span>
		</p><div class="example"><a name="id248881"></a><p class="title"><b>Example 1.1. Set <code class="varname">qos_flag</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("qos", "qos_flag", 7)
...
route {
  ...
  if (method=="INVITE") {
    setflag(7); # Set the qos flag
	create_dialog(); # create the dialog
  }
  ...
}
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248903"></a>1.5. Exported Functions</h2></div></div></div><p>There are no exported functions that could be used in scripts.
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248913"></a>1.6. Exported Statistics</h2></div></div></div><p>There are no exported statistics for the qos module.</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293408"></a>1.7. Exported MI Functions</h2></div></div></div><p>There are no exported MI functions for the qos module.
	Check the dialog MI functions for a way to inspect the internals
	of a dialog.
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293419"></a>1.8. Exported pseudo-variables</h2></div></div></div><p>There are no exported pseudo-variables for the qos module.
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293428"></a>1.9. Installation and Running</h2></div></div></div><p>Just load the module and remember to set the flag.
	</p></div></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id293440"></a>Chapter 2. Developer Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293458"></a>2.1. Available Functions</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293443"></a>2.1.1. 
		<code class="function">register_qoscb (qos, type, cb, param)</code>
		</h3></div></div></div><p>Register a new callback to the qos.</p><p>Meaning of the parameters is as follows:</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>struct qos_ctx_st* qos</em></span> - qos to 
			register callback to. If maybe NULL only for QOSCB_CREATED callback
			type, which is not a per qos type.
			</p></li><li><p><span class="emphasis"><em>int type</em></span> - types of callbacks; more
			types may be register for the same callback function; only 
			QOSCB_CREATED must be register alone. Possible types:
			</p><div class="itemizedlist"><ul type="circle"><li><p><span class="emphasis"><em>QOSCB_CREATED</em></span> - called when a new 
				qos context is created - it's a global type (not associated to 
				any qos).
				</p></li><li><p><span class="emphasis"><em>QOSCB_ADD_SDP</em></span> - called when a new SDP
				was added to the qos context - it's a per qos type.
				</p></li><li><p><span class="emphasis"><em>QOSCB_UPDATE_SDP</em></span> - called when an
				existing SDP is updated - it's a per qos type.
				</p></li><li><p><span class="emphasis"><em>QOSCB_REMOVE_SDP</em></span> - called when an 
				existing SDP is removed - it's a per qos type.
				</p></li><li><p><span class="emphasis"><em>QOSCB_TERMINATED</em></span> - called when the 
				qos is terminated.
				</p></li></ul></div><p>
			</p></li><li><p><span class="emphasis"><em>qos_cb cb</em></span> - callback function to be 
			called. Prototype is: &#8220;<span class="quote">void (qos_cb) 
			(struct qos_ctx_st *qos, int type, struct qos_cb_params *params);
			</span>&#8221;
			</p></li><li><p><span class="emphasis"><em>void *param</em></span> - parameter to be passed to
			the callback function.
			</p></li></ul></div></div></div></div></div></body></html>
